// Definicija klase obojenih crteza (Crtez).

#ifndef _crtez_h_
#define _crtez_h_

#include "figura2.h"
#include "pravoug2.h"
#include <vector>
using namespace std;

namespace Figure {
  class Crtez: public Figura {
    Tacka A;                                       // Donje levo teme.
    double s, v;                                   // Sirina i visina.
    vector<Figura*> figure;                        // Figure u crtezu.
    void kopiraj(const Crtez& crt);                // Kopiranje u crtez.
    void premesti(Crtez& crt);                     // Premestanje u crtez.
    void brisi();                                  // Oslobadjanje memorije.
  public:                                          // Konstruktori:
    explicit Crtez(const Tacka& T=Tacka(),         // - podrazumevani i
      double sir=1, double vis=1, Boja bb=Boja()): //   "obican",
      Figura(bb), s(sir), v(vis), A(T) {}
    Crtez(const Crtez& crt): Figura(crt)           // - kopirajuci,
      { kopiraj(crt); }
    Crtez(Crtez&& crt): Figura(crt)                // - premestajuci.
      { premesti(crt); }
    ~Crtez() { brisi(); }                          // Destruktor.
    Crtez& operator=(const Crtez& crt) {           // Kopirajuca dodela
      if (this != &crt) {                          //    vrednosti.
        brisi(); Figura::operator=(crt); kopiraj(crt);
      }
      return *this;
    }
    Crtez& operator=(Crtez&& crt) {                // Premestajuca dodela
      if (this != &crt) {                          //    vrednosti.
        brisi(); Figura::operator=(crt); premesti(crt);
      }
      return *this;
    }
    Crtez* kopija() const override                 // Kopija.
      { return new Crtez(*this); }
    char vrsta() const override { return 'C'; }    // Oznaka vrste figure.
    Crtez& operator+=(Figura* fig)                 // Dodavanje figure.
      { figure.push_back(fig); return *this; }
    Boja boja(const Tacka& T) const override;      // Boja tacke.
  private:
    bool pripada(const Tacka& T) const override    // Da li tacka pripada?
      { return T < Pravoug(A,Tacka(A.uzmi_x()+s,A.uzmi_y()+v)); }
    void pisi(ostream& it) const override;         // Pisanje.
  }; // class Crtez
} // namespace Figure

#endif

